
package acm;

import java.util.Scanner;

/**
 *
 * @author cteam030
 */
public class Grasshop {

    public static void main(String[] args) {

        Scanner s = new Scanner(System.in);
        
        while(s.hasNext())
        {
            int width = s.nextInt();
            int height = s.nextInt();
            
            int[][] array = new int[width+1][height+1];
            
            for(int i = 0; i < width; i++)
            {
                for(int j = 0; j < height; j++)
                {
                    array[i][j] = -1;
                }
            }
            
            int startx = s.nextInt();
            int starty = s.nextInt();
            int finishx = s.nextInt();
            int finishy = s.nextInt();
            
            array[startx][starty] = 0; // start
            array[finishx][finishy] = -2; // finish
            
            boolean impossible = false;
            int step = 0;
            
            while(!impossible)
            {
                boolean stepPossible = false;
                
                for(int i = 0; i < width; i++)
                {
                    for(int j = 0; j < height; j++)
                    {
                        if(array[i][j] == step)
                        {
                            int[][] jumps = {{1, 3},{3, 1},{3, -1},{1, -3},
                                         {-1, -3},{3, -1},{-3, 1},{-1, 3}};
                            
                            for(int k = 0; k < 8; k++)
                            {
                                int sx = i+jumps[k][0];
                                int sy = j+jumps[k][1];
                                
                                if(sx > 0 && sx < width
                                        && sy > 0 && sy < height)
                                {
                                    
                                    if(array[sx][sy] == -2)
                                    {
                                        System.out.println(step + 1);
                                        break;
                                    }
                                    
                                    if(array[sx][sy] == -1)
                                    {
                                        array[sx][sy] = step + 1;
                                        stepPossible = true;
                                    }
                                    
                                }
                            }
                        }
                    }
                }
                
                if(!stepPossible)
                {
                    System.out.println("impossible");
                    break;
                }
                
                step++;
            }
            
        }
    }

}
